SystemOrganization addCategory: #WorkPlayRatioScheduler!

!Canvas methodsFor: '*WorkPlayRatioScheduler' stamp: 'HwaJong 12/29/2012 18:38'!
drawCenterString: aString from: startingStringIndex to: endingStringIndex in: aRectangle font: fontOrNil color: aColor 
	|rect font width height |
	
	font := fontOrNil ifNil: [TextStyle defaultFont].
	width := font widthOfStringOrText: (aString copyFrom: startingStringIndex to: endingStringIndex).
	height := font height.
	rect := (aRectangle origin + ((aRectangle extent)/2) - ((width @ height)/2)) truncated corner: aRectangle corner.
	
	^self drawString: aString from: startingStringIndex to: endingStringIndex in: rect font: font color: aColor ! !

!Canvas methodsFor: '*WorkPlayRatioScheduler' stamp: 'HwaJong 12/29/2012 18:31'!
drawCenterString: aByteString in: aRectangle 
	^self drawCenterString: aByteString from: 1 to: aByteString size in: aRectangle font: nil color: Color black! !

Object subclass: #WPRSFormOutput
	instanceVariableNames: 'scheduler waffle form canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WPRSFormOutput methodsFor: 'changing' stamp: 'HwaJong 12/29/2012 18:46'!
compute
	form := Form extent: self formWidth @ self formHeight depth: 1.
	canvas := FormCanvas on: form.
	canvas fillColor: Color white.
	canvas line: self hrStartX stop @ self rowHeight to: self hrEndX @ self rowHeight color: Color black.
	canvas line: self firstLineX @ self lineStartY to: self firstLineX @ self lineEndY color: Color black.
	canvas line: self secondLineX @ self lineStartY to: self secondLineX @ self lineEndY color: Color black.
	canvas line: self thirdLineX @ self lineStartY to: self thirdLineX @ self lineEndY color: Color black.
	canvas drawCenterString: 'Work' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 1).
	canvas drawCenterString: 'Play' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 2).
	canvas drawCenterString: 'Work' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 3).
	canvas drawCenterString: 'Play' in: (waffle boundsOfIndentationAtRow: 1 atColumn: 4).
	(1 to: (scheduler schedule size min: 20))
		do: [ :index | 
			| pair |
			pair := scheduler schedule at: index.
			canvas drawCenterString: pair first printString in: (waffle boundsOfIndentationAtRow: index + 1 atColumn: 1).
			canvas drawCenterString: pair second printString in: (waffle boundsOfIndentationAtRow: index + 1 atColumn: 2) ].
	((21) to: scheduler schedule size)
		do: [ :index | 
			| pair dIndex |
			dIndex := index - 20.
			pair := scheduler schedule at: index.
			canvas drawCenterString: pair first printString in: (waffle boundsOfIndentationAtRow: dIndex + 1 atColumn: 3).
			canvas drawCenterString: pair second printString in: (waffle boundsOfIndentationAtRow: dIndex + 1 atColumn: 4) ].
	canvas drawString: Date today printString at: 90 @ (self lineEndY + 7)! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:57'!
dateMargin
	^43! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:50'!
firstLineX
	^(waffle columnSegments rangeOfSegmentAtIndex: 3) start! !

!WPRSFormOutput methodsFor: 'accessing' stamp: 'HwaJong 12/29/2012 18:19'!
form
	^ form! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 18:07'!
formHeight
	^waffle bounds height + self dateMargin! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:48'!
formWidth
	^waffle bounds width! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:38'!
hrEndX
	^self formWidth-10! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:48'!
hrStartX
	^waffle columnSegments rangeOfSegmentAtIndex: 1! !

!WPRSFormOutput methodsFor: 'initialize-release' stamp: 'HwaJong 12/29/2012 18:50'!
initialize
	super initialize.
	self initializeWaffle.! !

!WPRSFormOutput methodsFor: 'initialize-release' stamp: 'HwaJong 12/29/2012 18:50'!
initializeWaffle
	|cw|
	waffle := WFWaffleLayout new.
	waffle addFixedRowSegment: 0.
	waffle addFixedRowSegment: 15.
	waffle addFixedRowSegment: 1.
	20
		timesRepeat: [ 
			waffle addFixedRowSegment: 18.
			waffle addFixedRowSegment: 1 ].
	cw := 69.
	waffle addFixedColumnSegment: 10.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 1.
	waffle addFixedColumnSegment: cw.
	waffle addFixedColumnSegment: 10.
	waffle bounds: (0 @ 0 extent: (waffle columnSegments sumOfLengthOfFixedSegments) @ (waffle rowSegments sumOfLengthOfFixedSegments)).! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:36'!
lineEndY
	^self formHeight - self dateMargin.! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:35'!
lineStartY
	^0! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 10:32'!
rowHeight
	^15! !

!WPRSFormOutput methodsFor: 'accessing' stamp: 'HwaJong 12/27/2012 10:30'!
scheduler: aWorkPlayRatioScheduler 
	scheduler := aWorkPlayRatioScheduler! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:50'!
secondLineX
	^(waffle columnSegments rangeOfSegmentAtIndex: 5) start! !

!WPRSFormOutput methodsFor: 'self evaluating' stamp: 'HwaJong 12/29/2012 17:51'!
thirdLineX 
	^(waffle columnSegments rangeOfSegmentAtIndex: 7) start! !

Object subclass: #WorkPlayRatioScheduler
	instanceVariableNames: 'workMin workPerPlayRatio mins schedule tempBisectVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 12/27/2012 18:24'!
outputScheduleForm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 23 minute: 0 second: 0) meals: 2.
s workPerPlayRatio: 9/3.
s workMin: 1.
s compute. 
s schedule explore.
s openForm.
s saveFormToPNGName: '/Users/daliot/Desktop/print.png'.! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:02'!
ratio4hour4
|s|
s := WorkPlayRatioScheduler new.
s hours: 4.
s workPerPlayRatio: 4.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:03'!
ratio5hour8
|s|
s := WorkPlayRatioScheduler new.
s hours: 8.
s workPerPlayRatio: 5.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 12/27/2012 18:24'!
work5play3upto9pm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 21 minute: 0 second: 0) meals: 3.
s workPerPlayRatio: 5/3.
s workMin: 1.
s compute. 
^s schedule.

! !

!WorkPlayRatioScheduler methodsFor: 'adding' stamp: 'HwaJong 11/23/2012 14:56'!
addEntryToSchedule
schedule addLast: self workPlayEntry! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 15:00'!
compute
[self addEntryToSchedule.
self reduceMin.
mins > 0]
	whileTrue:
		[self increaseWorkMin].! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
hours: anInteger
self mins: anInteger * 60! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 14:50'!
increaseWorkMin
workMin := workMin + 1! !

!WorkPlayRatioScheduler methodsFor: 'initialize-release' stamp: 'HwaJong 12/27/2012 10:19'!
initialize 
super initialize.
schedule := OrderedCollection new.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
mins: anInteger
mins := anInteger! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:54'!
openForm
	self scheduleForm asMorph openInWindowLabeled: 'Schedule'! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:48'!
playMin
^(workMin / workPerPlayRatio) rounded max: 1! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 14:50'!
reduceMin
mins := mins - workMin - self playMin.! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:53'!
saveFormToPNGName: aString 
	PNGReadWriter putForm: self scheduleForm onFileNamed: aString! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 15:00'!
schedule
	^ schedule! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/27/2012 10:49'!
scheduleForm
	^WPRSFormOutput new
		scheduler: self;
		compute;
		form.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin
	^ workMin! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin: anInteger
	workMin := anInteger
! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio
	^ workPerPlayRatio! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio: aNumber
	workPerPlayRatio := aNumber
! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:49'!
workPlayEntry
^{workMin . self playMin}! !

!WorkPlayRatioScheduler methodsFor: 'express access' stamp: 'HwaJong 12/27/2012 18:23'!
workUpTo: aTime meals: anInteger

	self mins: (((aTime asSeconds - Time now asSeconds) / 60) truncated - (60*anInteger)).! !
